/*>>> sanmer.c: SAN project move execution and retraction routines */

/* Revised: 1993.05.16 */

#include <stdio.h>
#include <time.h>

#include "sandef.h"
#include "sanvar.h"

#include "sanatk.h"
#include "sangen.h"
#include "sanmer.h"
#include "sanmsc.h"
#include "sanutl.h"

/*--> SANExecute: execute the current move */
nonstatic
void
SANExecute(void)
{
mptrT mptr;
eT next_e;

/* test for overflow */

if (an == (aL - 1))
	SANFatal("SANExecute: overflow");

/* set the move pointer */

mptr = curr_g.g_curr;

/* set the legality tested flag */

mptr->m_flag |= mf_exec;

/* process according to move case */

switch (mptr->m_scmv)
	{
	case scmv_reg:
		if (curr_e.e_actc == c_w)
			{
			if (mptr->m_tocp != cp_v0)
				{
				cpmv[c_b] -= valcpv[mptr->m_tocp];
				SANSubPiece(mptr->m_tosq);
				};
			plv[c_w][biv[mptr->m_tosq] = biv[mptr->m_frsq]] = mptr->m_tosq;
			}
		else
			{
			if (mptr->m_tocp != cp_v0)
				{
				cpmv[c_w] -= valcpv[mptr->m_tocp];
				SANSubPiece(mptr->m_tosq);
				};
			plv[c_b][biv[mptr->m_tosq] = biv[mptr->m_frsq]] = mptr->m_tosq;
			};
		gb.bv[mptr->m_frsq] = cp_v0;
		gb.bv[mptr->m_tosq] = mptr->m_frcp;
		break;

	case scmv_epc:
		cpmv[curr_e.e_pasc] -= val_p;
		if (curr_e.e_actc == c_w)
			SANSubPiece(mptr->m_tosq + dv_3);
		else
			SANSubPiece(mptr->m_tosq + dv_1);
		plv[curr_e.e_actc][biv[mptr->m_tosq] = biv[mptr->m_frsq]] =
			mptr->m_tosq;
		gb.bv[mptr->m_frsq] = cp_v0;
		gb.bv[mptr->m_tosq] = mptr->m_frcp;
		if (curr_e.e_actc == c_w)
			gb.bv[mptr->m_tosq + dv_3] = cp_v0;
		else
			gb.bv[mptr->m_tosq + dv_1] = cp_v0;
		break;

	case scmv_cks:
		if (curr_e.e_actc == c_w)
			{
			gb.bv[sq_e1] = cp_v0;   gb.bv[sq_g1] = cp_wk;
			gb.bv[sq_h1] = cp_v0;   gb.bv[sq_f1] = cp_wr;
			biv[plv[c_w][kingslot] = sq_g1] = kingslot;
			plv[c_w][biv[sq_f1] = biv[sq_h1]] = sq_f1;
			}
		else
			{
			gb.bv[sq_e8] = cp_v0;   gb.bv[sq_g8] = cp_bk;
			gb.bv[sq_h8] = cp_v0;   gb.bv[sq_f8] = cp_br;
			biv[plv[c_b][kingslot] = sq_g8] = kingslot;
			plv[c_b][biv[sq_f8] = biv[sq_h8]] = sq_f8;
			};
		break;

	case scmv_cqs:
		if (curr_e.e_actc == c_w)
			{
			gb.bv[sq_e1] = cp_v0;   gb.bv[sq_c1] = cp_wk;
			gb.bv[sq_a1] = cp_v0;   gb.bv[sq_d1] = cp_wr;
			biv[plv[c_w][kingslot] = sq_c1] = kingslot;
			plv[c_w][biv[sq_d1] = biv[sq_a1]] = sq_d1;
			}
		else
			{
			gb.bv[sq_e8] = cp_v0;   gb.bv[sq_c8] = cp_bk;
			gb.bv[sq_a8] = cp_v0;   gb.bv[sq_d8] = cp_br;
			biv[plv[c_b][kingslot] = sq_c8] = kingslot;
			plv[c_b][biv[sq_d8] = biv[sq_a8]] = sq_d8;
			};
		break;

	case scmv_ppn:
		cpmv[curr_e.e_actc] += val_n - val_p;
		if (mptr->m_tocp != cp_v0)
			{
			SANSubPiece(mptr->m_tosq);
			cpmv[curr_e.e_pasc] -= valcpv[mptr->m_tocp];
			};
		gb.bv[mptr->m_frsq] = cp_v0;
		if (curr_e.e_actc == c_w)
			gb.bv[mptr->m_tosq] = cp_wn;
		else
			gb.bv[mptr->m_tosq] = cp_bn;
		plv[curr_e.e_actc][biv[mptr->m_tosq] = biv[mptr->m_frsq]] =
			mptr->m_tosq;
		break;

	case scmv_ppb:
		cpmv[curr_e.e_actc] += val_b - val_p;
		if (mptr->m_tocp != cp_v0)
			{
			SANSubPiece(mptr->m_tosq);
			cpmv[curr_e.e_pasc] -= valcpv[mptr->m_tocp];
			};
		gb.bv[mptr->m_frsq] = cp_v0;
		if (curr_e.e_actc == c_w)
			gb.bv[mptr->m_tosq] = cp_wb;
		else
			gb.bv[mptr->m_tosq] = cp_bb;
		plv[curr_e.e_actc][biv[mptr->m_tosq] = biv[mptr->m_frsq]] =
			mptr->m_tosq;
		break;

	case scmv_ppr:
		cpmv[curr_e.e_actc] += val_r - val_p;
		if (mptr->m_tocp != cp_v0)
			{
			SANSubPiece(mptr->m_tosq);
			cpmv[curr_e.e_pasc] -= valcpv[mptr->m_tocp];
			};
		gb.bv[mptr->m_frsq] = cp_v0;
		if (curr_e.e_actc == c_w)
			gb.bv[mptr->m_tosq] = cp_wr;
		else
			gb.bv[mptr->m_tosq] = cp_br;
		plv[curr_e.e_actc][biv[mptr->m_tosq] = biv[mptr->m_frsq]] =
			mptr->m_tosq;
		break;

	case scmv_ppq:
		cpmv[curr_e.e_actc] += val_q - val_p;
		if (mptr->m_tocp != cp_v0)
			{
			SANSubPiece(mptr->m_tosq);
			cpmv[curr_e.e_pasc] -= valcpv[mptr->m_tocp];
			};
		gb.bv[mptr->m_frsq] = cp_v0;
		if (curr_e.e_actc == c_w)
			gb.bv[mptr->m_tosq] = cp_wq;
		else
			gb.bv[mptr->m_tosq] = cp_bq;
		plv[curr_e.e_actc][biv[mptr->m_tosq] = biv[mptr->m_frsq]] =
			mptr->m_tosq;
		break;
	};

/* set values for next environment record: colors */

next_e.e_actc = curr_e.e_pasc;
next_e.e_pasc = curr_e.e_actc;

/* set values for next environment record: castling */

next_e.e_cast = curr_e.e_cast;
if (next_e.e_cast != 0)
	{
	if (next_e.e_cast & cast_wk)
		if ((mptr->m_frsq == sq_e1) || (mptr->m_frsq == sq_h1) ||
			(mptr->m_tosq == sq_h1))
			next_e.e_cast &= ~cast_wk;

	if (next_e.e_cast & cast_wq)
		if ((mptr->m_frsq == sq_e1) || (mptr->m_frsq == sq_a1) ||
			(mptr->m_tosq == sq_a1))
			next_e.e_cast &= ~cast_wq;

	if (next_e.e_cast & cast_bk)
		if ((mptr->m_frsq == sq_e8) || (mptr->m_frsq == sq_h8) ||
			(mptr->m_tosq == sq_h8))
			next_e.e_cast &= ~cast_bk;

	if (next_e.e_cast & cast_bq)
		if ((mptr->m_frsq == sq_e8) || (mptr->m_frsq == sq_a8) ||
			(mptr->m_tosq == sq_a8))
			next_e.e_cast &= ~cast_bq;
	};

/* set values for next environment record: en passant */

if (curr_e.e_actc == c_w)
	if ((mptr->m_frcp == cp_wp) &&
		(map_rank_sq(mptr->m_frsq) == rank_2) &&
		(map_rank_sq(mptr->m_tosq) == rank_4))
		next_e.e_epsq = mptr->m_frsq + dv_1;
	else
		next_e.e_epsq = sq_nil;
else
	if ((mptr->m_frcp == cp_bp) &&
		(map_rank_sq(mptr->m_frsq) == rank_7) &&
		(map_rank_sq(mptr->m_tosq) == rank_5))
		next_e.e_epsq = mptr->m_frsq + dv_3;
	else
		next_e.e_epsq = sq_nil;

/* set values for next environment record: halfmove clock */

if ((mptr->m_tocp != cp_v0) || (cv_p_cpv[mptr->m_frcp] == p_p))
	next_e.e_hmvc = 0;
else
	next_e.e_hmvc = curr_e.e_hmvc + 1;

/* set move number + check/bust flags according to active color  */

if (curr_e.e_actc == c_w)
	{
	next_e.e_fmvn = curr_e.e_fmvn;
	if (SANBlackInCheck())
		mptr->m_flag |= mf_chec;
	if (SANWhiteInCheck())
		mptr->m_flag |= mf_bust;
	}
else
	{
	next_e.e_fmvn = curr_e.e_fmvn + 1;
	if (SANWhiteInCheck())
		mptr->m_flag |= mf_chec;
	if (SANBlackInCheck())
		mptr->m_flag |= mf_bust;
	};

/* save old environment and generation records */

av[an].a_e = curr_e;
av[an].a_g = curr_g;

/* update the global environment and generation */

curr_e = next_e;
curr_g.g_flag = 0;

/* increment ply */

an++;

return;
}

/*--> SANRetract: retract the previous move */
nonstatic
void
SANRetract(void)
{
mptrT mptr;

/* decrement ply */

an--;

/* restore the current environment and generation */

curr_e = av[an].a_e;
curr_g = av[an].a_g;

/* set the move pointer */

mptr = curr_g.g_curr;

/* process by move case */

switch (mptr->m_scmv)
	{
	case scmv_reg:
		gb.bv[mptr->m_tosq] = mptr->m_tocp;
		gb.bv[mptr->m_frsq] = mptr->m_frcp;
		if (curr_e.e_actc == c_w)
			{
			plv[c_w][biv[mptr->m_frsq] = biv[mptr->m_tosq]] = mptr->m_frsq;
			if (mptr->m_tocp != cp_v0)
				{
				SANAddPiece(mptr->m_tosq);
				cpmv[c_b] += valcpv[mptr->m_tocp];
				};
			}
		else
			{
			plv[c_b][biv[mptr->m_frsq] = biv[mptr->m_tosq]] = mptr->m_frsq;
			if (mptr->m_tocp != cp_v0)
				{
				SANAddPiece(mptr->m_tosq);
				cpmv[c_w] += valcpv[mptr->m_tocp];
				};
			};
		break;

	case scmv_epc:
		gb.bv[mptr->m_tosq] = cp_v0;
		gb.bv[mptr->m_frsq] = mptr->m_frcp;
		if (curr_e.e_actc == c_w)
			gb.bv[mptr->m_tosq + dv_3] = cp_bp;
		else
			gb.bv[mptr->m_tosq + dv_1] = cp_wp;
		if (curr_e.e_actc == c_w)
			SANAddPiece(mptr->m_tosq + dv_3);
		else
			SANAddPiece(mptr->m_tosq + dv_1);
		plv[curr_e.e_actc][biv[mptr->m_frsq] = biv[mptr->m_tosq]] =
			mptr->m_frsq;
		cpmv[curr_e.e_pasc] += val_p;
		break;

	case scmv_cks:
		if (curr_e.e_actc == c_w)
			{
			gb.bv[sq_g1] = cp_v0;   gb.bv[sq_e1] = cp_wk;
			gb.bv[sq_f1] = cp_v0;   gb.bv[sq_h1] = cp_wr;
			biv[plv[c_w][kingslot] = sq_e1] = kingslot;
			plv[c_w][biv[sq_h1] = biv[sq_f1]] = sq_h1;
			}
		else
			{
			gb.bv[sq_g8] = cp_v0;   gb.bv[sq_e8] = cp_bk;
			gb.bv[sq_f8] = cp_v0;   gb.bv[sq_h8] = cp_br;
			biv[plv[c_b][kingslot] = sq_e8] = kingslot;
			plv[c_b][biv[sq_h8] = biv[sq_f8]] = sq_h8;
			}
		break;

	case scmv_cqs:
		if (curr_e.e_actc == c_w)
			{
			gb.bv[sq_c1] = cp_v0;   gb.bv[sq_e1] = cp_wk;
			gb.bv[sq_d1] = cp_v0;   gb.bv[sq_a1] = cp_wr;
			biv[plv[c_w][kingslot] = sq_e1] = kingslot;
			plv[c_w][biv[sq_a1] = biv[sq_d1]] = sq_a1;
			}
		else
			{
			gb.bv[sq_c8] = cp_v0;   gb.bv[sq_e8] = cp_bk;
			gb.bv[sq_d8] = cp_v0;   gb.bv[sq_a8] = cp_br;
			biv[plv[c_b][kingslot] = sq_e8] = kingslot;
			plv[c_b][biv[sq_a8] = biv[sq_d8]] = sq_a8;
			};
		break;

	case scmv_ppn:
		cpmv[curr_e.e_actc] -= val_n - val_p;
		plv[curr_e.e_actc][biv[mptr->m_frsq] = biv[mptr->m_tosq]] =
			mptr->m_frsq;
		gb.bv[mptr->m_tosq] = mptr->m_tocp;
		gb.bv[mptr->m_frsq] = mptr->m_frcp;
		if (mptr->m_tocp != cp_v0)
			{
			SANAddPiece(mptr->m_tosq);
			cpmv[curr_e.e_pasc] += valcpv[mptr->m_tocp];
			};
		break;

	case scmv_ppb:
		cpmv[curr_e.e_actc] -= val_b - val_p;
		plv[curr_e.e_actc][biv[mptr->m_frsq] = biv[mptr->m_tosq]] =
			mptr->m_frsq;
		gb.bv[mptr->m_tosq] = mptr->m_tocp;
		gb.bv[mptr->m_frsq] = mptr->m_frcp;
		if (mptr->m_tocp != cp_v0)
			{
			SANAddPiece(mptr->m_tosq);
			cpmv[curr_e.e_pasc] += valcpv[mptr->m_tocp];
			};
		break;

	case scmv_ppr:
		cpmv[curr_e.e_actc] -= val_r - val_p;
		plv[curr_e.e_actc][biv[mptr->m_frsq] = biv[mptr->m_tosq]] =
			mptr->m_frsq;
		gb.bv[mptr->m_tosq] = mptr->m_tocp;
		gb.bv[mptr->m_frsq] = mptr->m_frcp;
		if (mptr->m_tocp != cp_v0)
			{
			SANAddPiece(mptr->m_tosq);
			cpmv[curr_e.e_pasc] += valcpv[mptr->m_tocp];
			};
		break;

	case scmv_ppq:
		cpmv[curr_e.e_actc] -= val_q - val_p;
		plv[curr_e.e_actc][biv[mptr->m_frsq] = biv[mptr->m_tosq]] =
			mptr->m_frsq;
		gb.bv[mptr->m_tosq] = mptr->m_tocp;
		gb.bv[mptr->m_frsq] = mptr->m_frcp;
		if (mptr->m_tocp != cp_v0)
			{
			SANAddPiece(mptr->m_tosq);
			cpmv[curr_e.e_pasc] += valcpv[mptr->m_tocp];
			};
		break;
	};

return;
}

/*<<< sanmer.c: EOF */
